import { Job } from "..";
import { PipInstallRequirementsProps } from "../python/scripts";
export interface PagesSphinxProps {
    readonly pip?: PipInstallRequirementsProps;
    /**
     * The name of the job.
     */
    readonly jobName?: string;
    /**
     * The stage of the job.
     */
    readonly jobStage?: string;
}
export interface IPagesSphinx {
    pip?: PipInstallRequirementsProps;
}
/**
 * Runs `sphinx-build -b html -E -a docs public/${CI_COMMIT_REF_NAME}` and
 * installs project requirements.
 * Uses: (`PythonScripts.PipInstallRequirements()`)
 *
 * - Requires a `docs/requirements.txt` in your project folder` containing
 *   at least `sphinx`
 * - Creates artifacts for Gitlab Pages under `pages`
 *
 * This subclass of `Job` will configure following defaults for the superclass:
 *
 * - name: sphinx-pages
 * - stage: build
 * - artifacts: Path 'public'
 */
export declare class PagesSphinx extends Job implements IPagesSphinx {
    pip?: PipInstallRequirementsProps;
    constructor(props: PagesSphinxProps);
    render(): any;
}
